Trigger [triggers.tekton.dev/v1beta1]

Description
Trigger defines a mapping of an input event to parameters. This is used to extract information from events to be passed to TriggerTemplates within a Trigger.
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

Spec holds the desired state of the Trigger

.spec

Description
Spec holds the desired state of the Trigger
Type
object
Required
bindingstemplate
PropertyTypeDescription
bindingsarray
interceptorsarray
namestring
serviceAccountNamestring

ServiceAccountName optionally associates credentials with each trigger; Unlike EventListeners, this should be scoped to the same namespace as the Trigger itself

templateobject

.spec.bindings

Type
array

.spec.bindings[]

Type
object
PropertyTypeDescription
apiversionstring

APIVersion of the binding ref

kindstring

Kind can only be provided if Ref is also provided. Defaults to TriggerBinding

namestring

Name is the name of the binding param Mutually exclusive with Ref

refstring

Ref is a reference to a TriggerBinding kind. Mutually exclusive with Name

valuestring

Value is the value of the binding param. Can contain JSONPath Has to be pointer since "" is a valid value Required if Name is also specified.

.spec.interceptors

Type
array

.spec.interceptors[]

Description
TriggerInterceptor provides a hook to intercept and pre-process events
Type
object
Required
ref
PropertyTypeDescription
bitbucketobject

BitbucketInterceptor provides a webhook to intercept and pre-process events

celobject

CELInterceptor provides a webhook to intercept and pre-process events

githubobject

Deprecated old fields below

gitlabobject

GitLabInterceptor provides a webhook to intercept and pre-process events

namestring

Optional name to identify the current interceptor configuration

paramsarray

Params are the params to send to the interceptor

refobject

Ref refers to the Interceptor to use

webhookobject

WebhookInterceptor refers to an old style webhook interceptor service

.spec.interceptors[].bitbucket

Description
BitbucketInterceptor provides a webhook to intercept and pre-process events
Type
object
PropertyTypeDescription
eventTypesarray
secretRefobject

SecretRef contains the information required to reference a single secret string This is needed because the other secretRef types are not cross-namespace and do not actually contain the "SecretName" field, which allows us to access a single secret value.

.spec.interceptors[].bitbucket.eventTypes

Type
array

.spec.interceptors[].bitbucket.eventTypes[]

Type
string

.spec.interceptors[].bitbucket.secretRef

Description
SecretRef contains the information required to reference a single secret string This is needed because the other secretRef types are not cross-namespace and do not actually contain the "SecretName" field, which allows us to access a single secret value.
Type
object
PropertyTypeDescription
secretKeystring
secretNamestring

.spec.interceptors[].cel

Description
CELInterceptor provides a webhook to intercept and pre-process events
Type
object
PropertyTypeDescription
filterstring
overlaysarray

.spec.interceptors[].cel.overlays

Type
array

.spec.interceptors[].cel.overlays[]

Description
CELOverlay provides a way to modify the request body using DeprecatedCEL expressions
Type
object
PropertyTypeDescription
expressionstring
keystring

.spec.interceptors[].github

Description
Deprecated old fields below
Type
object
PropertyTypeDescription
eventTypesarray
secretRefobject

SecretRef contains the information required to reference a single secret string This is needed because the other secretRef types are not cross-namespace and do not actually contain the "SecretName" field, which allows us to access a single secret value.

.spec.interceptors[].github.eventTypes

Type
array

.spec.interceptors[].github.eventTypes[]

Type
string

.spec.interceptors[].github.secretRef

Description
SecretRef contains the information required to reference a single secret string This is needed because the other secretRef types are not cross-namespace and do not actually contain the "SecretName" field, which allows us to access a single secret value.
Type
object
PropertyTypeDescription
secretKeystring
secretNamestring

.spec.interceptors[].gitlab

Description
GitLabInterceptor provides a webhook to intercept and pre-process events
Type
object
PropertyTypeDescription
eventTypesarray
secretRefobject

SecretRef contains the information required to reference a single secret string This is needed because the other secretRef types are not cross-namespace and do not actually contain the "SecretName" field, which allows us to access a single secret value.

.spec.interceptors[].gitlab.eventTypes

Type
array

.spec.interceptors[].gitlab.eventTypes[]

Type
string

.spec.interceptors[].gitlab.secretRef

Description
SecretRef contains the information required to reference a single secret string This is needed because the other secretRef types are not cross-namespace and do not actually contain the "SecretName" field, which allows us to access a single secret value.
Type
object
PropertyTypeDescription
secretKeystring
secretNamestring

.spec.interceptors[].params

Description
Params are the params to send to the interceptor
Type
array

.spec.interceptors[].params[]

Description
InterceptorParams defines a key-value pair that can be passed on an interceptor
Type
object
Required
namevalue
PropertyTypeDescription
namestring
value

.spec.interceptors[].ref

Description
Ref refers to the Interceptor to use
Type
object
PropertyTypeDescription
apiVersionstring

API version of the referent

kindstring

InterceptorKind indicates the kind of the Interceptor, namespaced or cluster scoped.

namestring

Name of the referent; More info: http://kubernetes.io/docs/user-guide/identifiers#names

.spec.interceptors[].webhook

Description
WebhookInterceptor refers to an old style webhook interceptor service
Type
object
PropertyTypeDescription
headerarray

Header is a group of key-value pairs that can be appended to the interceptor request headers. This allows the interceptor to make decisions specific to an EventListenerTrigger.

objectRefobject

ObjectRef is a reference to an object that will resolve to a cluster DNS name to use as the EventInterceptor. Either objectRef or url can be specified

urlstring

.spec.interceptors[].webhook.header

Description
Header is a group of key-value pairs that can be appended to the interceptor request headers. This allows the interceptor to make decisions specific to an EventListenerTrigger.
Type
array

.spec.interceptors[].webhook.header[]

Description
Param declares an ParamValues to use for the parameter called name.
Type
object
Required
namevalue
PropertyTypeDescription
namestring
valueobject

ParamValue is a type that can hold a single string or string array. Used in JSON unmarshalling so that a single JSON field can accept either an individual string or an array of strings.

.spec.interceptors[].webhook.header[].value

Description
ParamValue is a type that can hold a single string or string array. Used in JSON unmarshalling so that a single JSON field can accept either an individual string or an array of strings.
Type
object

.spec.interceptors[].webhook.objectRef

Description
ObjectRef is a reference to an object that will resolve to a cluster DNS name to use as the EventInterceptor. Either objectRef or url can be specified
Type
object
PropertyTypeDescription
apiVersionstring

API version of the referent.

fieldPathstring

If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.

kindstring

Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

namestring

Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

namespacestring

Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

resourceVersionstring

Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

uidstring

UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids

.spec.template

Type
object
PropertyTypeDescription
apiversionstring
refstring
specobject

TriggerTemplateSpec holds the desired state of TriggerTemplate

.spec.template.spec

Description
TriggerTemplateSpec holds the desired state of TriggerTemplate
Type
object
PropertyTypeDescription
paramsarray
resourcetemplatesarray

.spec.template.spec.params

Type
array

.spec.template.spec.params[]

Description
ParamSpec defines an arbitrary named input whose value can be supplied by a `Param`.
Type
object
Required
name
PropertyTypeDescription
defaultstring

Default is the value a parameter takes if no input value via a Param is supplied.

descriptionstring

Description is a user-facing description of the parameter that may be used to populate a UI.

namestring

Name declares the name by which a parameter is referenced.

.spec.template.spec.resourcetemplates

Type
array

.spec.template.spec.resourcetemplates[]

Description
TriggerResourceTemplate describes a resource to create
Type
object

API Endpoints

The following API endpoints are available:

  • /apis/triggers.tekton.dev/v1alpha1/namespaces/{namespace}/triggers
    • DELETE: delete collection of Trigger
    • GET: list objects of kind Trigger
    • POST: create a new Trigger
  • /apis/triggers.tekton.dev/v1alpha1/namespaces/{namespace}/triggers/{name}
    • DELETE: delete the specified Trigger
    • GET: read the specified Trigger
    • PATCH: partially update the specified Trigger
    • PUT: replace the specified Trigger

/apis/triggers.tekton.dev/v1alpha1/namespaces/{namespace}/triggers

HTTP method
DELETE
Description
delete collection of Trigger
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind Trigger
HTTP responses
HTTP codeResponse body
200 - OKTriggerList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new Trigger
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyTrigger schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKTrigger schema
201 - CreatedTrigger schema
202 - AcceptedTrigger schema
401 - UnauthorizedEmpty

/apis/triggers.tekton.dev/v1alpha1/namespaces/{namespace}/triggers/{name}

HTTP method
DELETE
Description
delete the specified Trigger
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified Trigger
HTTP responses
HTTP codeResponse body
200 - OKTrigger schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified Trigger
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKTrigger schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified Trigger
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyTrigger schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKTrigger schema
201 - CreatedTrigger schema
401 - UnauthorizedEmpty